package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/cache"
	"fmt"
	"xorm.io/xorm"
)

// VirtualCoinListInUse 查询正在使用中的虚拟币
func VirtualCoinListInUse(Db *xorm.Engine, masterId string) ([]*model.VirtualCoin, error) {
	var m []*model.VirtualCoin
	cacheKey := fmt.Sprintf(md.VirtualCoinCfgCacheKey, masterId)

	err := cache.GetJson(cacheKey, &m)
	if err != nil || len(m) == 0 {
		err := Db.Where("is_use=1").Find(&m)
		if err != nil {
			return nil, err
		}
		cache.SetJson(cacheKey, m, md.CfgCacheTime)
	}

	return m, nil
}
